_G.ExpresBrewingCo = {}
local expresBrewingCo = _G.ExpresBrewingCo
local myFrame = CreateFrame("frame", "ExpresBrewingCo")
expresBrewingCo.frame = CreateFrame("Frame", "ExpresBrewingCoUI", UIParent)
-- Orient our UI Frame
expresBrewingCo.frame:SetSize(185, 80)
expresBrewingCo.frame:SetPoint("CENTER", UIParent )
expresBrewingCo.frame:SetMovable(true)
expresBrewingCo.frame:EnableMouse(true)
expresBrewingCo.frame:SetClampedToScreen( true )
expresBrewingCo.frame:RegisterForDrag("LeftButton")
expresBrewingCo.frame:SetUserPlaced(true)
expresBrewingCo.frame:SetScript("OnDragStart", expresBrewingCo.frame.StartMoving)
expresBrewingCo.frame:SetScript("OnDragStop", expresBrewingCo.frame.StopMovingOrSizing)
expresBrewingCo.frame.graphFrame = CreateFrame("Frame", "ExpresBrewingCoUIGraphs", expresBrewingCo.frame)
expresBrewingCo.frame.graphFrame:SetPoint("CENTER", expresBrewingCo.frame )
expresBrewingCo.frame.graphFrame:SetSize(185, 80)
expresBrewingCo.frame.graphFrame:SetFrameStrata("LOW")
expresBrewingCo.frame.graphFrame:SetBackdrop({
    bgFile   = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 12,
    insets = { left = 3, right = 3, top = 3, bottom = 3, },
})
expresBrewingCo.frame.overlayFrame = CreateFrame("Frame", "ExpresBrewingCoUIOverlay", expresBrewingCo.frame)
expresBrewingCo.frame.overlayFrame:SetPoint("CENTER", expresBrewingCo.frame )
expresBrewingCo.frame.overlayFrame:SetSize(185, 80)
expresBrewingCo.frame.overlayFrame:SetFrameStrata("MEDIUM")
-- Build HP Tracker
expresBrewingCo.frame.graphFrame.bars = {}
expresBrewingCo.frame.graphFrame.bars.maxHp = {}
expresBrewingCo.frame.graphFrame.bars.minHp = {}
for i = 1, 60, 1 do
  local bar = CreateFrame("StatusBar", nil, expresBrewingCo.frame.graphFrame)
  bar:SetOrientation("VERTICAL")
	bar:SetPoint("TOPLEFT", (i * 3), -3)
	bar:SetPoint("BOTTOMLEFT", (i * 3), 3)
	bar:SetWidth(3)
	bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	bar:GetStatusBarTexture():SetHorizTile(false)
	bar:GetStatusBarTexture():SetVertTile(false)
	bar:SetStatusBarColor(0.6, 0.9, 1)
	bar:EnableMouse(false)
  bar:SetMinMaxValues(0, 100)
  bar:SetValue(100)
  bar:SetFrameStrata("LOW")
  bar:SetFrameLevel(100)
  expresBrewingCo.frame.graphFrame.bars.maxHp[60- (i - 1)] = bar

  local bar2 = CreateFrame("StatusBar", nil, expresBrewingCo.frame.graphFrame)
  bar2:SetOrientation("VERTICAL")
	bar2:SetPoint("TOPLEFT", (i * 3), -3)
	bar2:SetPoint("BOTTOMLEFT", (i * 3), 3)
	bar2:SetWidth(3)
	bar2:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	bar2:GetStatusBarTexture():SetHorizTile(false)
	bar2:GetStatusBarTexture():SetVertTile(false)

  bar2:SetStatusBarColor(0.3, 1, 0.3)
	bar2:EnableMouse(false)
  bar2:SetMinMaxValues(0, 100)
  bar2:SetValue(100)
  bar2:SetFrameStrata("LOW")
  bar2:SetFrameLevel(102)
  expresBrewingCo.frame.graphFrame.bars.minHp[60- (i - 1)] = bar2
end

expresBrewingCo.frame.hpReadout = expresBrewingCo.frame.overlayFrame:CreateFontString(nil, "MEDIUM")
expresBrewingCo.frame.hpReadout:SetPoint("TOPLEFT", expresBrewingCo.frame, "TOPLEFT", 8, -4)
expresBrewingCo.frame.hpReadout:SetFont("Fonts\\FRIZQT__.TTF", 22, "OUTLINE")
expresBrewingCo.frame.hpReadout:SetJustifyH("LEFT")
expresBrewingCo.frame.hpReadout:SetShadowOffset(1, -1)
expresBrewingCo.frame.hpReadout:SetTextColor(1, 0, 0)
-- Initialize the text with an empty string
expresBrewingCo.frame.hpReadout:SetText("")

expresBrewingCo.frame.staggerReadout = expresBrewingCo.frame.overlayFrame:CreateFontString(nil, "MEDIUM")
expresBrewingCo.frame.staggerReadout:SetPoint("TOPLEFT", expresBrewingCo.frame, "TOPLEFT", 8, -32)
expresBrewingCo.frame.staggerReadout:SetFont("Fonts\\FRIZQT__.TTF", 22, "OUTLINE")
expresBrewingCo.frame.staggerReadout:SetJustifyH("LEFT")
expresBrewingCo.frame.staggerReadout:SetShadowOffset(1, -1)
expresBrewingCo.frame.staggerReadout:SetTextColor(0.9, 0.7, 0)
-- Initialize the text with an empty string
expresBrewingCo.frame.staggerReadout:SetText("")

-- HP Tracking
expresBrewingCo.lowestHp = {}
expresBrewingCo.highestHp = {}

expresBrewingCo.lowestHpBars = {}
expresBrewingCo.highestHpBars = {}


ExpresBrewingCo_UpdateInterval = 0.1; -- How often the OnUpdate code will run (in seconds)
expresBrewingCo.TimeSinceLastUpdate = 0;
function expresBrewingCo:OnUpdate(elapsed)
  expresBrewingCo.TimeSinceLastUpdate = expresBrewingCo.TimeSinceLastUpdate + elapsed;
  if (expresBrewingCo.TimeSinceLastUpdate < ExpresBrewingCo_UpdateInterval) then
    return
  end
  local maxHP = UnitHealthMax("player")
  local currentHp = UnitHealth("player")
  local missingHP = maxHP - currentHp
  local missingHPPCT = (missingHP / maxHP) * 100
  local currentHpPct = (currentHp / maxHP) * 100
  expresBrewingCo.frame.hpReadout:SetText(("-%dk %.2f%%"):format(missingHP/1000, missingHPPCT))

  local currentStagger = UnitStagger("player")
  local staggerPCT = (currentStagger / UnitHealthMax("player")) * 100
  expresBrewingCo.frame.staggerReadout:SetText(("%dk %.2f%%"):format(currentStagger/1000, staggerPCT))

  local now = time()
  if expresBrewingCo.lowestHp[now] then
    if currentHpPct < expresBrewingCo.lowestHp[now] then
      expresBrewingCo.lowestHp[now] = currentHpPct
    end
  else
    expresBrewingCo.lowestHp[now] = currentHpPct
  end

  if expresBrewingCo.highestHp[now] then
    if currentHpPct > expresBrewingCo.highestHp[now] then
      expresBrewingCo.highestHp[now] = currentHpPct
    end
  else
    expresBrewingCo.highestHp[now] = currentHpPct
  end

  for i = 1, 60, 1 do
    local max = expresBrewingCo.highestHp[now - (i - 1)]
    local min = expresBrewingCo.lowestHp[now -  (i - 1)]
    if max then
      local bar = expresBrewingCo.frame.graphFrame.bars.maxHp[i]
      if bar then
        bar:SetValue(max)
      end
    end
    if min then
      local bar2 = expresBrewingCo.frame.graphFrame.bars.minHp[i]
      if bar2 then
        bar2:SetValue(min)
      end
    end
  end
  -- -- Change things to an array using modulo devision to find the proper idx
  -- for k,v in pairs(expresBrewingCo.lowestHp) do
  --   if k < (now - 62) then
  --     expresBrewingCo.lowestHp[k] = nil
  --   end
  -- end
  --
  -- for k,v in pairs(expresBrewingCo.highestHp) do
  --   if k < (now - 62) then
  --     expresBrewingCo.highestHp[k] = nil
  --   end
  -- end
end

function expresBrewingCo:playerLogin()
	myFrame:SetScript("OnUpdate", expresBrewingCo.OnUpdate )

	DEFAULT_CHAT_FRAME:AddMessage( "Expres Brewing Co. laoded", 0.5, 1, 0.831 )
end

function OnEvent(self, event, ...)
  local arg1 = select(1, ...) or ""
  if event == "COMBAT_LOG_EVENT_UNFILTERED" then
  elseif event == "PLAYER_LOGIN" then
    local localizedClass, englishClass = UnitClass("player")
    if englishClass ~= "MONK" then
      DEFAULT_CHAT_FRAME:AddMessage( "Expres Brewing Co.: This character is not a monk, not loading.", 0.5, 1, 0.831 )
      expresBrewingCo.frame:Hide()
      return
    end
    expresBrewingCo:playerLogin()
  end
end


myFrame:RegisterEvent("PLAYER_LOGIN")
myFrame:RegisterEvent("ADDON_LOADED")
myFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
-- myFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
myFrame:SetScript("OnEvent", OnEvent)
